#include <mega8535.h>
#include <delay.h>
#include <Initialization_CPU.h>
#include <peremenie_konst.h>

/******************************************* ************************************************/
#define dig1I PORTA.2//PORTD.5         dig1I
#define dig2I PORTA.1//PORTD.6         dig2I
#define dig3I PORTA.0//PORTD.7        dig3I
#define dig1U PORTA.5//PORTD.5         dig1U
#define dig2U PORTA.4//PORTD.6         dig2U
#define dig3U PORTA.3//PORTD.7        dig3U

 void recoding (void){
  unsigned char sym[]={
  0b10000001, //(0)0
  0b11110011, //(1)1
  0b01001001, //(2)2
  0b01100001, //(3)3
  0b00110011, //(4)4
  0b00100101, //(5)5
  0b00000101, //(6)6
  0b11110001, //(7)7
  0b00000001, //(8)8
  0b00100001, //(9)9
  0b00001101, //(10)E
  0b01011111, //(11)r
  0b11111111  //(12)  
  };
 volatile unsigned char indy_static_I;//         
 volatile unsigned char indy_static_U;//         
 volatile unsigned char cur_dig=0;      //  
 volatile unsigned char sym_out[6];   // sym_out   ( 6)        
 volatile unsigned char indy_I;       //         
 volatile unsigned char indy_U;       //                      
 /******************************************** *************************************************/
   if (divider_indy==1){   //    (divider_indy   ,    )
   indy_I=izmerenoe_I;     //          ()
   indy_static_I=indy_I;   // indy_static_I        
   indy_U=izmerenoe_U;     //          ()
   indy_static_U=indy_U;   // indy_static_U        
   if (indy_static_I<255){ //  indy_static_I  255
   sym_out[0]=indy_I%10;   //  sym_out 0     
   indy_I=indy_I/10;       //  indy_I         
   sym_out[1]=indy_I%10;   //    
   indy_I=indy_I/10;       //    
   sym_out[2]=indy_I;      //      
   }
   else                    // 
   {
   sym_out[0]=11;          //
   sym_out[1]=10;          //Er
   sym_out[2]=12;          // 0   
   }
   /*************************************** *********************************************/
   if (indy_static_U<255){  //  indy_static_U  255
   sym_out[3]=indy_U%10;    //  sym_out 0     
   indy_U=indy_U/10;        //  indy_I         
   sym_out[4]=indy_U%10;    //    
   indy_U=indy_U/10;        //    
   sym_out[5]=indy_U;       //      
   }
   else                     // 
   {
   sym_out[3]=11;           //
   sym_out[4]=10;           //Er
   sym_out[5]=12;           // 0   
   }

    /***********************************     **************************************/
   PORTC=sym[12];                                                         //  C
   switch (cur_dig){                                                      //   
   case 0:{dig1I=1; dig2I=0; dig3I=0; dig1U=0; dig2U=0; dig3U=0; break;}; //    1 
   case 1:{dig2I=1; dig3I=0; dig1I=0; dig1U=0; dig2U=0; dig3U=0; break;}; //    2 
   case 2:{dig3I=1; dig1I=0; dig2I=0; dig1U=0; dig2U=0; dig3U=0; break;}; //    3 
   case 3:{dig1U=1; dig3I=0; dig1I=0; dig2I=0; dig2U=0; dig3U=0; break;}; //    1 
   case 4:{dig2U=1; dig1U=0; dig3I=0; dig1I=0; dig2I=0; dig3U=0; break;}; //    2 
   case 5:{dig3U=1; dig2U=0; dig1U=0; dig3I=0; dig1I=0; dig2I=0; break;}; //    3 
   }

   if (indy_static_I<10){    //  adc_dataI<10
   dig2I=0; dig1I=0;         // 2  
   }
   
   if (indy_static_I<100){   //  adc_dataI<100
   dig2I=0;                  // 1  
   }
   
   if (indy_static_U<10){    //  adc_dataI<10
   dig2U=0; dig1U=0;         // 2  
   }
   
   if (indy_static_U<100){   //  adc_dataI<100
   dig2U=0;                  // 1  
   }
   
   if (divider_indy==1){
   PORTC=sym[sym_out[cur_dig]];   //   C   
   cur_dig=cur_dig+1;             //  cur_dig  1
    if (cur_dig==6){
    cur_dig=0;                    //  cur_dig     5
    }
   }
  }
 divider_indy=0;                  //    
 }